SystemOrganization addCategory: #'PetitPreprocessor-Core'!
SystemOrganization addCategory: #'PetitPreprocessor-Tests'!

PPAbstractParserTest subclass: #PPPreProcessingParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitPreprocessor-Tests'!

!PPPreProcessingParserTest commentStamp: '<historical>' prior: 0!
A PPPreProcessingParserTest is xxxxxxxxx.

Instance Variables

Double inclusion:
yoyoLiYYbTeYYlTluTlYYeyoyo

==>

yoyoLiYYbeYYllulYYeyoyo

==>

yoyoLibelluleyoyo
!

!PPPreProcessingParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/12/2012 10:33'!
testBiggerReplacementThanMatching
	|preProcessingParser|	
	preProcessingParser := 'Troll' asParser preProcess: ('u' asRegex) into: 'll'. 
	self assert: (('Un' asParser, preProcessingParser, 'DeTroy' asParser) end matches: 'UnTrouDeTroy')! !

!PPPreProcessingParserTest methodsFor: 'as yet unclassified' stamp: ''!
testCalculateRelativePositionRelativePositionIncludeAnotherInterval
	"In this test, the first interval will be ignored because it is before the PreProcessingParser starting position and the second which transform 5 characters in 0 have to be reverted, so it will add 5 to the position"
	self assert: (PPPreProcessingParser calculateRelativePositionTo: 9 ignoringBefore: 0 accordingTo: {(3 to: 4).(7 to: 8).(13 to: 14)} transformedInto: '') equals: 15.! !

!PPPreProcessingParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/12/2012 14:41'!
testDecomposedEntry
	|preProcessingParser|	
	preProcessingParser := 'Libellule' asParser preProcess: 'T' asRegex into: ''.
	self assert: (preProcessingParser end matches: 'LibTelTluTle')! !

!PPPreProcessingParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/12/2012 14:41'!
testDecomposedEntryConsumed
	|preProcessingParser|	
	preProcessingParser := 'Libellule' asParser preProcess: 'T' asRegex into: ''.
	self assert:  ((preProcessingParser, 'yoyo' asParser) matches:  'LibTelTluTleyoyo')! !

!PPPreProcessingParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/12/2012 14:42'!
testDoNotConsumeIfContainedParserDoNotMatch
	|preProcessingParser|	
	preProcessingParser :=  'aNonMatchingString' asParser preProcess: 'T' asRegex into: ''.
	self assert: ((preProcessingParser optional, 'LibTelTluTle' asParser) matches: 'LibTelTluTle')! !

!PPPreProcessingParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/12/2012 14:47'!
testDoubleInclusion
	| preProcessingParser parser |
	preProcessingParser := ('Libellule' asParser preProcess: 'Y+' asRegex into: '') preProcess: 'T' asRegex  into: ''.
	parser :=  'yoyo' asParser, preProcessingParser, 'yoyo' asParser.
	self assert: (parser matches: 'yoyoLiYYbTeYYlTluTlYYeyoyo').! !

!PPPreProcessingParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/12/2012 14:46'!
testMixingDataToPreProcessAndNot
	|preProcessingParser|	
	preProcessingParser := 'Libellule' asParser preProcess: 'T' asRegex into: ''.
	self assert: (('DoNoTPreProcess' asParser, preProcessingParser, 'NotThisToo' asParser) matches: 'DoNoTPreProcessLibTelTluTleNotThisToo')! !

!PPPreProcessingParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/5/2012 09:51'!
testPreprocess
	| preProcessor |
	preProcessor := PPPreProcessingParser new.
	preProcessor regexp: 'T' asRegex .
	preProcessor replacement: ''.
	self assert: 'My String' equals: (preProcessor preProcess: 'MTy TStrTingT' asPetitStream ) contents ! !

!PPPreProcessingParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/1/2012 11:10'!
testPreprocessWithPreviousContent
	| aStream preProcessor |
	preProcessor := PPPreProcessingParser new.
	preProcessor regexp: 'T' asRegex .
	preProcessor replacement: ''.
	self assert: 'My String' equals: (preProcessor preProcess: ('PreviousContentMTy TStrTingT' asPetitStream position: 15; yourself)) contents ! !

!PPPreProcessingParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/12/2012 14:49'!
testRelativePositionForDoubleInclusion
	|preProcessingParser token |	
	preProcessingParser := (('yoyo' asParser, ('Libellule' asParser info), 'yoyo' asParser) preProcess: 'Y+' asRegex into: '') preProcess: 'T' asRegex  into: ''.
	token := (preProcessingParser parse:  'yTYYoyTYYoLiYYbTeYYlTluTlYYeyToYYyTo') second.
	self assert: token start equals: 11.
	self assert: token stop equals: 28. ! !

!PPPreProcessingParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/12/2012 14:49'!
testRelativePositionForIncludedParser
	|preProcessingParser token |	
	preProcessingParser := (('yoyo' asParser, ('Libellule' asParser info), 'yoyo' asParser) preProcess: 'Y+' asRegex into: '') preProcess: 'T' asRegex  into: ''.
	token := (preProcessingParser parse:  'yToyToLibTelTluTleyToyTo') second.
	self assert: token start equals: 7.
	self assert: token stop equals: 18. ! !

!PPPreProcessingParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/12/2012 14:49'!
testWithPotentiallyPreprocessedDataAround
	|preProcessingParser|	
	preProcessingParser := 'Libellule' asParser preProcess: 'T' asRegex into: ''.
	self assert: (preProcessingParser end matches: 'TLibTelTluTleT')! !

!PPPreProcessingParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 5/31/2012 11:24'!
testWriteUntilIn
	| writeStream |
	writeStream := WriteStream with: ''.
	PPPreProcessingParser new write: 'Test String' asPetitStream until: 5 in: writeStream.
	
	self assert: writeStream contents equals: 'Test'! !

!PPParser methodsFor: '*petitpreprocessor-core' stamp: ''!
info
	"Answer a new parser that transforms the input to an info object, containing evaluation and positions."
	
	^ PPInfoParser on: self! !

!PPParser methodsFor: '*petitpreprocessor-core' stamp: 'guillaumelarcheveque 6/12/2012 14:47'!
preProcess: aRegex into: aReplacement
	^ PPPreProcessingParser new setParser: self; regexp: aRegex; replacement: aReplacement; yourself! !

TestCase subclass: #PPInfoParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitPreprocessor-Tests'!

!PPInfoParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/12/2012 11:12'!
testBasicInfo
	| nodes infos |
	nodes:= ('Lorem ipsum ' asParser, ('dolor' asParser token info),' sit amet' asParser) parse: 'Lorem ipsum dolor sit amet'.
	infos:= nodes second.
	self assert: infos start equals: 13.
	self assert: infos stop equals: 17.
	self assert: infos element start equals: infos start.
	self assert: infos element stop equals: infos stop.! !

!PPInfoParserTest methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/12/2012 11:19'!
testPreProcessedStreamInfo
	| nodes infos |
	nodes:= (('Lorem ipsum ' asParser, ('dolor' asParser token info),' sit amet' asParser) preProcess: '\[Sp\]' asRegex into: ' ') parse: 'Lorem[Sp]ipsum[Sp]dolor[Sp]sit[Sp]amet'.
	infos:= nodes second.
	self assert: infos start equals: 19.
	self assert: infos stop equals: 23.! !

PPDelegateParser subclass: #PPInfoParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitPreprocessor-Core'!

!PPInfoParser commentStamp: '<historical>' prior: 0!
A PPInfoParser is a containing parser providing the evaluation content and the stream content positions.

To use this, only send "info" to any PPParser:
'My Parser' asParser info

Instance Variables

!

!PPInfoParser methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/5/2012 15:46'!
create: element start: startInteger stop: stopInteger
	^ PPInfo on: element start: startInteger stop: stopInteger! !

!PPInfoParser methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/12/2012 11:06'!
parseOn: aStream
	| start element relativeStart |
	start := aStream position.
	relativeStart := aStream relativePosition.
	element := parser parseOn: aStream.
	element isPetitFailure ifTrue: [
		aStream position: start.
		^ element ].
	^ self create: element start: (relativeStart + 1) stop: (aStream relativePosition)! !

PPDelegateParser subclass: #PPPreProcessingParser
	instanceVariableNames: 'regexp replacement ranges startPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitPreprocessor-Core'!

!PPPreProcessingParser commentStamp: '<historical>' prior: 0!
A PPPreProcessingParser is a parser which apply a transformation on its entry stream and then makes its contained parser to parse this transformed stream .

To use this, send "preProcess: aRegex into: aReplacement" to a Parser for preProcessing the input stream for this parser.

example (remove the \n): 'Foo' asParser preProcess: ('\n' asRegex) into: '' 

Instance Variables
	preProcessingBlock:		<Object>

preProcessingBlock
	- xxxxx
!

!PPPreProcessingParser class methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/12/2012 10:32'!
calculateRelativePositionTo: anEndingPosition ignoringBefore: aStartingPosition accordingTo: aSetOfRanges transformedInto: aReplacement
	"Calculate position before preProcessing from the position after preProcessing"
	| relativePosition decalage localDecalage |
	relativePosition := anEndingPosition.
	"Decalage to obtain preProcessed position from unProcessed position"
	decalage := 0.
	aSetOfRanges do: [:aRange | 
		localDecalage := aReplacement size - aRange size. 
		"check if interval is included into parsed text"
		(((aRange first + decalage + localDecalage) >= aStartingPosition) & ((aRange last + decalage + localDecalage) <= anEndingPosition)) ifTrue: 
		[decalage := decalage + localDecalage] ].
	^ relativePosition - decalage ! !

!PPPreProcessingParser class methodsFor: 'as yet unclassified' stamp: ''!
createFrom: aCouple
	^ self new regexp: aCouple first asRegex; replacement: aCouple second! !

!PPPreProcessingParser class methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/4/2012 17:14'!
createFrom: aListOfCouple for: aParser
	| myParser |
	myParser:= self createFrom: (aListOfCouple first).
	aListOfCouple size = 1 ifTrue: [
		myParser setParser: aParser]
	ifFalse: [myParser setParser: (self createFrom: (aListOfCouple copyFrom: 2 to: aListOfCouple size) for: aParser)].
	^ myParser! !

!PPPreProcessingParser methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/5/2012 15:54'!
calculateRelativePositionTo: endingPosition
	^ self class calculateRelativePositionTo: endingPosition ignoringBefore: startPosition accordingTo: ranges transformedInto: replacement! !

!PPPreProcessingParser methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/11/2012 14:13'!
parseOn: aStream
	|result preProcessedStream |
	startPosition := aStream position.
	preProcessedStream := (self preProcess: aStream).
	"call the contained parser"
	result := super parseOn: preProcessedStream.
	result isPetitFailure 
		ifTrue: 
			"restore stream position"
			[aStream position: startPosition] 
		ifFalse: 
			"place unprocessed stream at the position corresponding to the processed stream after parsing"
			[aStream position: (self calculateRelativePositionTo: (startPosition + preProcessedStream position))].
	^ result.! !

!PPPreProcessingParser methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/5/2012 15:46'!
preProcess: aStream
	"Return a new stream and store all transformations"
	| result position|
	position := aStream position.
	ranges := regexp matchingRangesIn: aStream.
	aStream position: position.
	result := WriteStream with: ''.
	ranges do: [:aRange | self write: aStream until: (aRange first) in: result. result nextPutAll: replacement. aStream skip: aRange size ].
	aStream do: [:c | result nextPut: c].
	aStream position: position.
	^ PPRelativePositionStream on: (result contents) relativeTo: aStream with: ranges replacedBy: replacement! !

!PPPreProcessingParser methodsFor: 'accessing' stamp: ''!
ranges
	^ ranges! !

!PPPreProcessingParser methodsFor: 'accessing' stamp: ''!
ranges: anObject
	ranges := anObject! !

!PPPreProcessingParser methodsFor: 'accessing' stamp: ''!
regexp
	^ regexp! !

!PPPreProcessingParser methodsFor: 'accessing' stamp: ''!
regexp: anObject
	regexp := anObject! !

!PPPreProcessingParser methodsFor: 'accessing' stamp: ''!
replacement
	^ replacement! !

!PPPreProcessingParser methodsFor: 'accessing' stamp: ''!
replacement: anObject
	replacement := anObject! !

!PPPreProcessingParser methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/5/2012 09:32'!
setParser: aParser
	super setParser: aParser! !

!PPPreProcessingParser methodsFor: 'accessing' stamp: ''!
startPosition
	^ startPosition! !

!PPPreProcessingParser methodsFor: 'accessing' stamp: ''!
startPosition: anObject
	startPosition := anObject! !

!PPPreProcessingParser methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 5/31/2012 11:25'!
write: aStream until: aPosition in: aWriteStream
	[(aStream position + 1) < aPosition] whileTrue: [aWriteStream nextPut: aStream next]! !

PPStream subclass: #PPRelativePositionStream
	instanceVariableNames: 'ranges replacement relativeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitPreprocessor-Core'!

!PPRelativePositionStream commentStamp: '<historical>' prior: 0!
A PPRelativePositionStream is a specialized stream to get the relative position according to another stream.

Instance Variables
!

!PPRelativePositionStream class methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/5/2012 15:07'!
on: aStream relativeTo: aRelativeStream with: ranges replacedBy: replacement
	^ (super on: aStream) relativeStream: aRelativeStream; ranges: ranges; replacement: replacement; yourself! !

!PPRelativePositionStream methodsFor: 'accessing' stamp: ''!
ranges
	^ ranges! !

!PPRelativePositionStream methodsFor: 'accessing' stamp: ''!
ranges: anObject
	ranges := anObject! !

!PPRelativePositionStream methodsFor: 'as yet unclassified' stamp: 'guillaumelarcheveque 6/5/2012 17:18'!
relativePosition: aPosition
	^  relativeStream relativePosition: (PPPreProcessingParser calculateRelativePositionTo: aPosition ignoringBefore: 0 accordingTo: ranges transformedInto: replacement) ! !

!PPRelativePositionStream methodsFor: 'accessing' stamp: ''!
relativeStream
	^ relativeStream! !

!PPRelativePositionStream methodsFor: 'accessing' stamp: ''!
relativeStream: anObject
	relativeStream := anObject! !

!PPRelativePositionStream methodsFor: 'accessing' stamp: ''!
replacement
	^ replacement! !

!PPRelativePositionStream methodsFor: 'accessing' stamp: ''!
replacement: anObject
	replacement := anObject! !

!PPStream methodsFor: '*petitPreprocessor-core' stamp: ''!
relativePosition
	^ self relativePosition: self position! !

!PPStream methodsFor: '*petitPreprocessor-core' stamp: ''!
relativePosition: aPosition
	^ aPosition ! !

Object subclass: #PPInfo
	instanceVariableNames: 'element start stop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitPreprocessor-Core'!

!PPInfo commentStamp: '<historical>' prior: 0!
A PPInfo represent the informations around a parsing result and also contain this result. It is usefull to get parsing evaluation and stream position.

Instance Variables
	element:		<Object>
	start:		<Object>
	stop:		<Object>

element
	- xxxxx

start
	- xxxxx

stop
	- xxxxx
!

!PPInfo class methodsFor: 'as yet unclassified' stamp: ''!
new
	self error: 'Info can only be created using a dedicated constructor.'! !

!PPInfo class methodsFor: 'as yet unclassified' stamp: ''!
on: anElement start: aStartInteger stop: aStopInteger
	^ self basicNew 
		initializeOn: anElement
		start: aStartInteger stop: aStopInteger! !

!PPInfo methodsFor: 'accessing' stamp: ''!
element
	^ element! !

!PPInfo methodsFor: 'accessing' stamp: ''!
initializeOn: anElement start: aStartInteger stop: aStopInteger
	element := anElement.
	start := aStartInteger.
	stop := aStopInteger! !

!PPInfo methodsFor: 'accessing' stamp: ''!
start
	^ start! !

!PPInfo methodsFor: 'accessing' stamp: ''!
stop
	^ stop! !
